import { Router } from "express";
import AuthRoute from "./auth";
import JWTRoute from "./jwt";
import Public from "./public";
import RefreshTokenRoute from "./refresh";

const OAuthRoue: Router = Router();
OAuthRoue.post("/auth", AuthRoute);
OAuthRoue.get("/jwt", JWTRoute)
OAuthRoue.get("/public", Public)
OAuthRoue.get("/refresh", RefreshTokenRoute);
OAuthRoue.post("/refresh", RefreshTokenRoute);
export default OAuthRoue;